# coding: utf-8

import re
import six


from huaweicloudsdkcore.sdk_response import SdkResponse
from huaweicloudsdkcore.utils.http_utils import sanitize_for_serialization


class AddUserResponse(SdkResponse):


    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """

    sensitive_list = []

    openapi_types = {
        'id': 'str',
        'user_account': 'str',
        'name': 'str',
        'english_name': 'str',
        'phone': 'str',
        'country': 'str',
        'email': 'str',
        'sip_num': 'str',
        'vmr_list': 'list[UserVmrDTO]',
        'dept_code': 'str',
        'dept_name': 'str',
        'dept_name_path': 'str',
        'user_type': 'int',
        'admin_type': 'int',
        'signature': 'str',
        'title': 'str',
        'desc': 'str',
        'corp': 'CorpBasicInfoDTO',
        'function': 'UserFunctionDTO',
        'dev_type': 'QueryDeviceInfoResultDTO',
        'status': 'int',
        'sort_level': 'int',
        'hide_phone': 'bool',
        'vision_account': 'str',
        'third_account': 'str',
        'license': 'int',
        'active_time': 'int'
    }

    attribute_map = {
        'id': 'id',
        'user_account': 'userAccount',
        'name': 'name',
        'english_name': 'englishName',
        'phone': 'phone',
        'country': 'country',
        'email': 'email',
        'sip_num': 'sipNum',
        'vmr_list': 'vmrList',
        'dept_code': 'deptCode',
        'dept_name': 'deptName',
        'dept_name_path': 'deptNamePath',
        'user_type': 'userType',
        'admin_type': 'adminType',
        'signature': 'signature',
        'title': 'title',
        'desc': 'desc',
        'corp': 'corp',
        'function': 'function',
        'dev_type': 'devType',
        'status': 'status',
        'sort_level': 'sortLevel',
        'hide_phone': 'hidePhone',
        'vision_account': 'visionAccount',
        'third_account': 'thirdAccount',
        'license': 'license',
        'active_time': 'activeTime'
    }

    def __init__(self, id=None, user_account=None, name=None, english_name=None, phone=None, country=None, email=None, sip_num=None, vmr_list=None, dept_code=None, dept_name=None, dept_name_path=None, user_type=None, admin_type=None, signature=None, title=None, desc=None, corp=None, function=None, dev_type=None, status=None, sort_level=None, hide_phone=None, vision_account=None, third_account=None, license=None, active_time=None):
        """AddUserResponse - a model defined in huaweicloud sdk"""
        
        super(AddUserResponse, self).__init__()

        self._id = None
        self._user_account = None
        self._name = None
        self._english_name = None
        self._phone = None
        self._country = None
        self._email = None
        self._sip_num = None
        self._vmr_list = None
        self._dept_code = None
        self._dept_name = None
        self._dept_name_path = None
        self._user_type = None
        self._admin_type = None
        self._signature = None
        self._title = None
        self._desc = None
        self._corp = None
        self._function = None
        self._dev_type = None
        self._status = None
        self._sort_level = None
        self._hide_phone = None
        self._vision_account = None
        self._third_account = None
        self._license = None
        self._active_time = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if user_account is not None:
            self.user_account = user_account
        if name is not None:
            self.name = name
        if english_name is not None:
            self.english_name = english_name
        if phone is not None:
            self.phone = phone
        if country is not None:
            self.country = country
        if email is not None:
            self.email = email
        if sip_num is not None:
            self.sip_num = sip_num
        if vmr_list is not None:
            self.vmr_list = vmr_list
        if dept_code is not None:
            self.dept_code = dept_code
        if dept_name is not None:
            self.dept_name = dept_name
        if dept_name_path is not None:
            self.dept_name_path = dept_name_path
        if user_type is not None:
            self.user_type = user_type
        if admin_type is not None:
            self.admin_type = admin_type
        if signature is not None:
            self.signature = signature
        if title is not None:
            self.title = title
        if desc is not None:
            self.desc = desc
        if corp is not None:
            self.corp = corp
        if function is not None:
            self.function = function
        if dev_type is not None:
            self.dev_type = dev_type
        if status is not None:
            self.status = status
        if sort_level is not None:
            self.sort_level = sort_level
        if hide_phone is not None:
            self.hide_phone = hide_phone
        if vision_account is not None:
            self.vision_account = vision_account
        if third_account is not None:
            self.third_account = third_account
        if license is not None:
            self.license = license
        if active_time is not None:
            self.active_time = active_time

    @property
    def id(self):
        """Gets the id of this AddUserResponse.

        用户id

        :return: The id of this AddUserResponse.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AddUserResponse.

        用户id

        :param id: The id of this AddUserResponse.
        :type: str
        """
        self._id = id

    @property
    def user_account(self):
        """Gets the user_account of this AddUserResponse.

        账号

        :return: The user_account of this AddUserResponse.
        :rtype: str
        """
        return self._user_account

    @user_account.setter
    def user_account(self, user_account):
        """Sets the user_account of this AddUserResponse.

        账号

        :param user_account: The user_account of this AddUserResponse.
        :type: str
        """
        self._user_account = user_account

    @property
    def name(self):
        """Gets the name of this AddUserResponse.

        姓名

        :return: The name of this AddUserResponse.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this AddUserResponse.

        姓名

        :param name: The name of this AddUserResponse.
        :type: str
        """
        self._name = name

    @property
    def english_name(self):
        """Gets the english_name of this AddUserResponse.

        英文名称

        :return: The english_name of this AddUserResponse.
        :rtype: str
        """
        return self._english_name

    @english_name.setter
    def english_name(self, english_name):
        """Sets the english_name of this AddUserResponse.

        英文名称

        :param english_name: The english_name of this AddUserResponse.
        :type: str
        """
        self._english_name = english_name

    @property
    def phone(self):
        """Gets the phone of this AddUserResponse.

        联系电话

        :return: The phone of this AddUserResponse.
        :rtype: str
        """
        return self._phone

    @phone.setter
    def phone(self, phone):
        """Sets the phone of this AddUserResponse.

        联系电话

        :param phone: The phone of this AddUserResponse.
        :type: str
        """
        self._phone = phone

    @property
    def country(self):
        """Gets the country of this AddUserResponse.

        联系电话所属的国家

        :return: The country of this AddUserResponse.
        :rtype: str
        """
        return self._country

    @country.setter
    def country(self, country):
        """Sets the country of this AddUserResponse.

        联系电话所属的国家

        :param country: The country of this AddUserResponse.
        :type: str
        """
        self._country = country

    @property
    def email(self):
        """Gets the email of this AddUserResponse.

        邮箱

        :return: The email of this AddUserResponse.
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this AddUserResponse.

        邮箱

        :param email: The email of this AddUserResponse.
        :type: str
        """
        self._email = email

    @property
    def sip_num(self):
        """Gets the sip_num of this AddUserResponse.

        SIP号码

        :return: The sip_num of this AddUserResponse.
        :rtype: str
        """
        return self._sip_num

    @sip_num.setter
    def sip_num(self, sip_num):
        """Sets the sip_num of this AddUserResponse.

        SIP号码

        :param sip_num: The sip_num of this AddUserResponse.
        :type: str
        """
        self._sip_num = sip_num

    @property
    def vmr_list(self):
        """Gets the vmr_list of this AddUserResponse.

        云会议室列表

        :return: The vmr_list of this AddUserResponse.
        :rtype: list[UserVmrDTO]
        """
        return self._vmr_list

    @vmr_list.setter
    def vmr_list(self, vmr_list):
        """Sets the vmr_list of this AddUserResponse.

        云会议室列表

        :param vmr_list: The vmr_list of this AddUserResponse.
        :type: list[UserVmrDTO]
        """
        self._vmr_list = vmr_list

    @property
    def dept_code(self):
        """Gets the dept_code of this AddUserResponse.

        部门编码

        :return: The dept_code of this AddUserResponse.
        :rtype: str
        """
        return self._dept_code

    @dept_code.setter
    def dept_code(self, dept_code):
        """Sets the dept_code of this AddUserResponse.

        部门编码

        :param dept_code: The dept_code of this AddUserResponse.
        :type: str
        """
        self._dept_code = dept_code

    @property
    def dept_name(self):
        """Gets the dept_name of this AddUserResponse.

        部门名称

        :return: The dept_name of this AddUserResponse.
        :rtype: str
        """
        return self._dept_name

    @dept_name.setter
    def dept_name(self, dept_name):
        """Sets the dept_name of this AddUserResponse.

        部门名称

        :param dept_name: The dept_name of this AddUserResponse.
        :type: str
        """
        self._dept_name = dept_name

    @property
    def dept_name_path(self):
        """Gets the dept_name_path of this AddUserResponse.

        部门完整名称

        :return: The dept_name_path of this AddUserResponse.
        :rtype: str
        """
        return self._dept_name_path

    @dept_name_path.setter
    def dept_name_path(self, dept_name_path):
        """Sets the dept_name_path of this AddUserResponse.

        部门完整名称

        :param dept_name_path: The dept_name_path of this AddUserResponse.
        :type: str
        """
        self._dept_name_path = dept_name_path

    @property
    def user_type(self):
        """Gets the user_type of this AddUserResponse.

        用户类型 - 2：企业成员账户

        :return: The user_type of this AddUserResponse.
        :rtype: int
        """
        return self._user_type

    @user_type.setter
    def user_type(self, user_type):
        """Sets the user_type of this AddUserResponse.

        用户类型 - 2：企业成员账户

        :param user_type: The user_type of this AddUserResponse.
        :type: int
        """
        self._user_type = user_type

    @property
    def admin_type(self):
        """Gets the admin_type of this AddUserResponse.

        管理员类型 - 0：默认（超级）管理员 - 1：普通管理员 - 2：非管理员（即为普通企业成员，UserType是2时有效）

        :return: The admin_type of this AddUserResponse.
        :rtype: int
        """
        return self._admin_type

    @admin_type.setter
    def admin_type(self, admin_type):
        """Sets the admin_type of this AddUserResponse.

        管理员类型 - 0：默认（超级）管理员 - 1：普通管理员 - 2：非管理员（即为普通企业成员，UserType是2时有效）

        :param admin_type: The admin_type of this AddUserResponse.
        :type: int
        """
        self._admin_type = admin_type

    @property
    def signature(self):
        """Gets the signature of this AddUserResponse.

        签名

        :return: The signature of this AddUserResponse.
        :rtype: str
        """
        return self._signature

    @signature.setter
    def signature(self, signature):
        """Sets the signature of this AddUserResponse.

        签名

        :param signature: The signature of this AddUserResponse.
        :type: str
        """
        self._signature = signature

    @property
    def title(self):
        """Gets the title of this AddUserResponse.

        职位

        :return: The title of this AddUserResponse.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this AddUserResponse.

        职位

        :param title: The title of this AddUserResponse.
        :type: str
        """
        self._title = title

    @property
    def desc(self):
        """Gets the desc of this AddUserResponse.

        备注

        :return: The desc of this AddUserResponse.
        :rtype: str
        """
        return self._desc

    @desc.setter
    def desc(self, desc):
        """Sets the desc of this AddUserResponse.

        备注

        :param desc: The desc of this AddUserResponse.
        :type: str
        """
        self._desc = desc

    @property
    def corp(self):
        """Gets the corp of this AddUserResponse.


        :return: The corp of this AddUserResponse.
        :rtype: CorpBasicInfoDTO
        """
        return self._corp

    @corp.setter
    def corp(self, corp):
        """Sets the corp of this AddUserResponse.


        :param corp: The corp of this AddUserResponse.
        :type: CorpBasicInfoDTO
        """
        self._corp = corp

    @property
    def function(self):
        """Gets the function of this AddUserResponse.


        :return: The function of this AddUserResponse.
        :rtype: UserFunctionDTO
        """
        return self._function

    @function.setter
    def function(self, function):
        """Sets the function of this AddUserResponse.


        :param function: The function of this AddUserResponse.
        :type: UserFunctionDTO
        """
        self._function = function

    @property
    def dev_type(self):
        """Gets the dev_type of this AddUserResponse.


        :return: The dev_type of this AddUserResponse.
        :rtype: QueryDeviceInfoResultDTO
        """
        return self._dev_type

    @dev_type.setter
    def dev_type(self, dev_type):
        """Sets the dev_type of this AddUserResponse.


        :param dev_type: The dev_type of this AddUserResponse.
        :type: QueryDeviceInfoResultDTO
        """
        self._dev_type = dev_type

    @property
    def status(self):
        """Gets the status of this AddUserResponse.

        用户状态 * 0、正常 * 1、停用 

        :return: The status of this AddUserResponse.
        :rtype: int
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this AddUserResponse.

        用户状态 * 0、正常 * 1、停用 

        :param status: The status of this AddUserResponse.
        :type: int
        """
        self._status = status

    @property
    def sort_level(self):
        """Gets the sort_level of this AddUserResponse.

        通讯录排序等级，序号越低优先级越高

        :return: The sort_level of this AddUserResponse.
        :rtype: int
        """
        return self._sort_level

    @sort_level.setter
    def sort_level(self, sort_level):
        """Sets the sort_level of this AddUserResponse.

        通讯录排序等级，序号越低优先级越高

        :param sort_level: The sort_level of this AddUserResponse.
        :type: int
        """
        self._sort_level = sort_level

    @property
    def hide_phone(self):
        """Gets the hide_phone of this AddUserResponse.

        是否隐藏手机号码

        :return: The hide_phone of this AddUserResponse.
        :rtype: bool
        """
        return self._hide_phone

    @hide_phone.setter
    def hide_phone(self, hide_phone):
        """Sets the hide_phone of this AddUserResponse.

        是否隐藏手机号码

        :param hide_phone: The hide_phone of this AddUserResponse.
        :type: bool
        """
        self._hide_phone = hide_phone

    @property
    def vision_account(self):
        """Gets the vision_account of this AddUserResponse.

        智慧屏唯一账号

        :return: The vision_account of this AddUserResponse.
        :rtype: str
        """
        return self._vision_account

    @vision_account.setter
    def vision_account(self, vision_account):
        """Sets the vision_account of this AddUserResponse.

        智慧屏唯一账号

        :param vision_account: The vision_account of this AddUserResponse.
        :type: str
        """
        self._vision_account = vision_account

    @property
    def third_account(self):
        """Gets the third_account of this AddUserResponse.

        第三方账号，自动开户的第三方账号、Ideahub账号的sn等

        :return: The third_account of this AddUserResponse.
        :rtype: str
        """
        return self._third_account

    @third_account.setter
    def third_account(self, third_account):
        """Sets the third_account of this AddUserResponse.

        第三方账号，自动开户的第三方账号、Ideahub账号的sn等

        :param third_account: The third_account of this AddUserResponse.
        :type: str
        """
        self._third_account = third_account

    @property
    def license(self):
        """Gets the license of this AddUserResponse.

        许可证 * 0：商用； * 1：免费试用。 

        :return: The license of this AddUserResponse.
        :rtype: int
        """
        return self._license

    @license.setter
    def license(self, license):
        """Sets the license of this AddUserResponse.

        许可证 * 0：商用； * 1：免费试用。 

        :param license: The license of this AddUserResponse.
        :type: int
        """
        self._license = license

    @property
    def active_time(self):
        """Gets the active_time of this AddUserResponse.

        激活时间，utc时间戳

        :return: The active_time of this AddUserResponse.
        :rtype: int
        """
        return self._active_time

    @active_time.setter
    def active_time(self, active_time):
        """Sets the active_time of this AddUserResponse.

        激活时间，utc时间戳

        :param active_time: The active_time of this AddUserResponse.
        :type: int
        """
        self._active_time = active_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                if attr in self.sensitive_list:
                    result[attr] = "****"
                else:
                    result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        import simplejson as json
        if six.PY2:
            import sys
            reload(sys)
            sys.setdefaultencoding("utf-8")
        return json.dumps(sanitize_for_serialization(self), ensure_ascii=False)

    def __repr__(self):
        """For `print`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AddUserResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
